//Attila Sipos Ha8Sa 2020
//elkey by kb9rlw tnx! http://kb9rlw.blogspot.com/2017/05/the-arduino-based-super-simple-keyer.html
//#define debug
#define elkey_enabled //if you like to use external keyer // it


#include <SPI.h>        
#include <Wire.h>
#include <PDQ_GFX.h>        // PDQ: Core graphics library
#include "PDQ_ILI9341_config.h" // PDQ: ILI9341 pins and other setup for this sketch
#include "PDQ_ILI9341.h"      // PDQ: Hardware-specific driver library
#include <Encoder.h> 
#include "si5351.h"
#include <TimerOne.h> 

//ports
#define ILI9341_RESET 8 


PDQ_ILI9341 tft;      // PDQ: create LCD object (using pins in "PDQ_ILI9341_config.h")
//fonts
#include "Ink_Free54.h" 
#include "Segoe_Script16.h" 
#include "Segoe_Script12.h" 
#include "Segoe_Script8.h" 


Encoder myEnc(2,3); 
Si5351 si5351;

#define vox_delay 300 //ms
long time_now = 0;


const long IF = 4914900; //IF frequency
const long BFO = IF - 700; //BFO frequency 700Hz
unsigned int vfo = 600;
unsigned int vfo_old = vfo + 11111;
unsigned int vfo_A = 600; //7.xxx.xx0 Hz xxxxx -> vfo_A min 10Hz step
unsigned int vfo_B = 600; //7.xxx.xx0 Hz xxxxx -> vfo_A min 10Hz step
char osc = 'A';
byte df_old[5] = {"+0000"};
int enc_old  = 0; 
int freq_step = 1; //1-10Hz, 10-100Hz
byte freq_step_index = 1; //0--10Hz 1--100Hz 2--1KHz 3--10KHz
boolean CLK2 = false;
boolean sleep = false;
boolean tune = false;

long scan_button_last_time = 0;
long smeter_last_time = 0;
float magnitude_avarage = 0;
int magnitude_avarage_nr = 0;
int s_value_old = 0;
int text_x = 0;
int filter_old = -1;
boolean split = false;
int wpm = 20;
int scanner_W = 50;
int scanner_G = 1;
int scanner_start_old = -1;
int hour = 12;
int minute = 00;
int menu_index = 0;
int scanner_array[320];
int scanner_step = 156;
int scanner_start = 0;
int x_old = 0;
boolean scanner_loop = false;
int filter = 0;

int audioInPin = A1;
float magnitude ;
float coeff;
float Q1 = 0;
float Q2 = 0;
float sine;
float cosine;  
float sampling_freq=8928.0;
float target_freq=744.0; /// adjust for your needs see above
float n=48.0;  //// if you change  her please change next line also 
int testData[48];

//clock variables
int ido = 9999;
int ora = 12;
int perc = 0;
String sido = "12:00"; 
int timer_c = 0;
boolean ora_set = false;

//elkey variables
#define IDLE 0   // doing nothing
#define DASH 1   // playing a dash
#define DOT  2   // playing a dot
#define DELAY 3  // in the dot-length delay between two dot/dashes
const int DOTIN = 4;  //dot sense pin
const int DASHIN = 7; //dash sense pin
const int KEYOUT = 5; //keying output
const int sidetoneout = 6;
int dotLength;   // length of a dot in milliseconds
int dotVal;    // value of the dot paddle this sycle of main loop
int dashVal;   // value of the dash paddle this cycle of main loop
int oldDotVal;  // value of dot paddle last cycle 
int oldDashVal; // value of dash paddle last dial 
int currEltEndTime; // what time did the current element start    sounding (in milliseconds since powerup)
int currElt; // sate of what the keyer output is sending right now
int nextElt; // state the keyer will go into when current element ends 
int lastElt;        // previous state of the keyer
int time; 




int orange_shade(int intensity)
{
  int result;
  result = ((255-intensity*3 & 0xF8) << 8) | ((0xa2-intensity*2 & 0xFC) << 3) | (0 >> 3);
  return result;
}


void s_bar(int value) //value 0..34
{
 if (value > s_value_old)
  {
   for (int j = s_value_old;j < value;j++)
    for(int i = j*4; i<j*4+4; i++)
     tft.drawFastVLine(i,117,8,orange_shade(70-(i /2))); 
   s_value_old = value;
  }
  else
  {
    if (value > 0) value = s_value_old-1;
    tft.fillRect(value*4,117,s_value_old*4-value*4,8,ILI9341_BLACK);  
    s_value_old = value;
  }
}


void s_bar_print()
{
   tft.setTextColor(ILI9341_WHITE);
   tft.setFont(&Segoe_Script8);
   tft.setCursor(0,144);
   tft.print("LOW");
   tft.setCursor(110,144);
   tft.print("HIGH");
   for (int i = 0; i<60;i++)
    tft.drawFastVLine(i+40,132,4,((45+i*3 & 0xF8) << 8) | ((45+i*3 & 0xFC) << 3) | (45+i*3 >> 3));
} 

void filter_draw(int ww) //0..7 = 200Hz 1600Hz
{
int w = ww++;  
w = w * 6 + 12;  
int fx = 186;
tft.fillRect(150,110,74,30,ILI9341_BLACK);
for (int y = 0; y < 24; y++)
{
  if (y>=22)
    tft.drawFastHLine((fx-w/2+y/3)+(y-21),136-y,(w-(y*2)/3)-(y-20),orange_shade(72-y*3));  
     else
      {
      tft.drawFastHLine(fx-w/2+y/3,136-y,w-(y*2)/3,orange_shade(72-y*3));  
      tft.drawFastHLine(fx-(w-16)/2+y/3,136-y,(w-16)-(y*2)/3,orange_shade(70));  
      }
}
tft.setTextColor(ILI9341_WHITE);tft.setFont(&Segoe_Script8);
if (ww < 5)
 {
 tft.setCursor(164,144); tft.print(ww*200);tft.print(" Hz");
 }
 else
 {
 tft.setCursor(162,144); tft.print(ww*200);tft.print(" Hz");
 }
 tft.drawFastVLine(fx,113,18,ILI9341_WHITE);
}


void set_frq_step() //rotary push sw setting frq step
{
  int y = 100;
  switch (freq_step_index)
   {
   case 0: tft.fillRect(130,y,48,3,ILI9341_BLACK);
           freq_step = 1; freq_step_index++; break;
   case 1: for (int i = 0; i<48; i ++)
             tft.drawFastVLine(i+260,y,3,((255-i*5 & 0xF8) << 8) | ((255-i*5 & 0xFC) << 3) | (255-i*5 >> 3));    
           freq_step = 10; freq_step_index++; break;
   case 2: tft.fillRect(260,y,48,3,ILI9341_BLACK);
             for (int i = 0; i<48; i ++)
               tft.drawFastVLine(i+190,y,3,((255-i*5 & 0xF8) << 8) | ((255-i*5 & 0xFC) << 3) | (255-i*5 >> 3));    
           freq_step = 100; freq_step_index++; break;
   case 3: tft.fillRect(190,y,48,3,ILI9341_BLACK);
             for (int i = 0; i<48; i ++)
               tft.drawFastVLine(i+130,y,3,((255-i*5 & 0xF8) << 8) | ((255-i*5 & 0xFC) << 3) | (255-i*5 >> 3));    
           freq_step = 1000; freq_step_index = 0; break;           
   }          
}

void draw_title(int x, int y, int x_size)
{
 for (int i=0;i<18;i++)
  tft.drawFastHLine(x,y+i,x_size,orange_shade(26+i*3)); 
}

void draw_line(int x)
{
for (int i = 0; i<80; i ++)
  tft.drawFastVLine(x+i,28,4,orange_shade(i));
}

void scanner_line_disp()
{
int x = ((long(vfo)-scanner_start)*10)/scanner_step;
  
   tft.drawFastVLine(x_old,173,50-scanner_array[x_old],ILI9341_BLACK); 
   tft.drawFastVLine(x_old,223-scanner_array[x_old],scanner_array[x_old],0x003f);
    if ((x>=0) && (x<320))
    {
     tft.drawFastVLine(x,203,20,ILI9341_YELLOW);
     x_old = x;  
    } 
}


void freq_disp()
{
int y = 110;
tft.setTextColor(ILI9341_WHITE);
tft.setFont(&Ink_Free54);
int vfo_buffer = vfo;
int vfo_buffer_old = vfo_old;
     if ((vfo_buffer / 100000) != (vfo_buffer_old / 100000)) {tft.fillRect(18,y-73,51,58,ILI9341_BLACK);tft.setCursor(18,y); tft.print(vfo_buffer / 100000);}
     vfo_buffer = vfo % 100000;
     vfo_buffer_old = vfo_old % 100000;
     if ((vfo_buffer / 10000) != (vfo_buffer_old / 10000)) {tft.fillRect(76,y-73,51,58,ILI9341_BLACK);tft.setCursor(76,y); tft.print(vfo_buffer / 10000);}
     vfo_buffer = vfo % 10000;
     vfo_buffer_old = vfo_old % 10000;
     if ((vfo_buffer / 1000) != (vfo_buffer_old / 1000)) {tft.fillRect(134,y-73,51,58,ILI9341_BLACK);tft.setCursor(134,y); tft.print(vfo_buffer / 1000);}
     vfo_buffer = vfo % 1000;
     vfo_buffer_old = vfo_old % 1000;
     if ((vfo_buffer / 100) != (vfo_buffer_old / 100)) {tft.fillRect(192,y-73,51,58,ILI9341_BLACK);tft.setCursor(192,y); tft.print(vfo_buffer / 100);}
     vfo_buffer = vfo % 100;
     vfo_buffer_old = vfo_old % 100;     
     if ((vfo_buffer / 10) != (vfo_buffer_old / 10)) {tft.fillRect(256,y-73,51,58,ILI9341_BLACK);tft.setCursor(256,y); tft.print(vfo_buffer / 10);}     
  vfo_old = vfo;
  if (osc=='A')
   vfo_A = vfo;
    else
     vfo_B = vfo;
  delta_f_disp();
  scanner_line_disp();
}

void delta_f_disp()
{
int x = 236;  
int y = 142;
tft.setTextColor(ILI9341_WHITE);tft.setFont(&Segoe_Script16);
tft.setCursor(x,y); 
int deltaf;
 if (vfo_B >= vfo_A)
 {
  if (df_old[4]!="+")
   tft.fillRect(x,117,15,16,ILI9341_BLACK);
  tft.print("+");
   df_old[4] = "+";
  deltaf = vfo_B-vfo_A;
 }
   else
   {
   if (df_old[4]!="-")
    tft.fillRect(x,117,15,16,ILI9341_BLACK);
    tft.print("-");
    df_old[4] = "-";
    deltaf = vfo_A-vfo_B;
   }
tft.setCursor(x+16,y);     
byte df = deltaf /1000;
 if (df!=df_old[3])
  tft.fillRect(x+16,117,15,16,ILI9341_BLACK);
tft.print(df);
df_old[3] = df;
tft.setCursor(x+31,y);     
df = (deltaf % 1000)/100;
 if (df!=df_old[2])
  tft.fillRect(x+31,117,15,16,ILI9341_BLACK);
tft.print(df);
df_old[2] = df;
tft.setCursor(x+46,y);     
tft.print(".");
tft.setCursor(x+52,y);     
df = (deltaf % 100)/10;
 if (df!=df_old[1])
  tft.fillRect(x+52,117,15,16,ILI9341_BLACK);
tft.print(df);
df_old[1] = df;
tft.setCursor(x+67,y);     
df = deltaf % 10;
 if (df!=df_old[0])
  tft.fillRect(x+67,117,15,16,ILI9341_BLACK);
tft.print(df);
df_old[0] = df;
}

void get_signal_magnitude()
{
 for (char index = 0; index < n; index++)
  {
     testData[index] = analogRead(audioInPin);
  }
 
  for (char index = 0; index < n; index++){
    float Q0;
    Q0 = coeff * Q1 - Q2 + (float) testData[index];
    Q2 = Q1;
    Q1 = Q0;  
  }
  float magnitudeSquared = (Q1*Q1)+(Q2*Q2)-Q1*Q2*coeff;  
  magnitude = sqrt(magnitudeSquared);
  Q2 = 0;
  Q1 = 0;
  magnitude_avarage += magnitude;
  magnitude_avarage_nr++;
}

void scanner()
{
   int dd = 10;
   int mm = 5;
   int xx = 33;
   int dx = 0;
   int xo = 27;
   int of = 0;
   scanner_start = (vfo/100)*100-(scanner_W*100)/2;
  if (scanner_start < 0)
    scanner_start = 0;
  scanner_step = (scanner_W*100)/32;
si5351.set_freq(long (scanner_start*10+scanner_step+IF+7000000), SI5351_PLL_FIXED, SI5351_CLK0);
get_signal_magnitude();
magnitude = 0;

if (scanner_start!=scanner_start_old)
 {
   tft.setFont(&Segoe_Script8);
   tft.setTextColor(ILI9341_WHITE);
   tft.fillRect(0,224,319,16,ILI9341_BLACK);
    switch (scanner_W)
     {
      case 5 : dd = 5; mm = 1; xx = 66; break;
      case 10 : dd = 10; mm = 1; xx = 33; break;
      case 25 : dd = 5; mm = 5; xx = 66; of = 2; break;
     } 
    if ((scanner_start == 0)&&(scanner_W==5)) xo = 56;
    if ((scanner_start == 0)&&(scanner_W==25)) {xo = 56; of = 0;}
        
    for (int i = 0; i < dd; i++)
    {
      int tt = scanner_start/100+(i+1)*mm;
      if (tt >= 10) dx = 6;
      tft.setCursor(xo+i*xx-dx,240); tft.print(tt-of);
    }
   scanner_start_old = scanner_start; 
 }

 
  for (unsigned int x = 0; x < 320; x++)
   {
     si5351.set_freq(long (scanner_start*10+x*scanner_step+IF+7000000), SI5351_PLL_FIXED, SI5351_CLK0);
     get_signal_magnitude();
     int mm = 8000 / scanner_G;
     if (magnitude > mm) magnitude = mm;
     int rf = map(magnitude,0,mm,0,50);
     tft.drawFastVLine(x,173,50,ILI9341_BLACK); 
     tft.drawFastVLine(x,223-rf,rf,0x003f);
     scanner_array[x] = rf;
   }
  si5351.set_freq(long (vfo*10+IF+7000000), SI5351_PLL_FIXED, SI5351_CLK0);   
  scanner_line_disp();
}

void menu_setting()
{
 switch (menu_index)
 {
 case 0: ora_set = false; orakiir(); break;
 case 1: tft.setTextColor(ILI9341_RED); tft.setFont(&Segoe_Script12);tft.setCursor(60,170); tft.print(wpm); break;
 case 2: tft.setTextColor(ILI9341_WHITE); tft.setFont(&Segoe_Script12);tft.setCursor(60,170); tft.print(wpm); 
         tft.setTextColor(ILI9341_RED);tft.setCursor(157,170); tft.print(scanner_W); break;
 case 3: tft.setTextColor(ILI9341_WHITE);tft.setFont(&Segoe_Script12);tft.setCursor(157,170); tft.print(scanner_W);        
         tft.setTextColor(ILI9341_RED);tft.setCursor(202,170); tft.print(scanner_G); break;
 case 4: tft.setTextColor(ILI9341_WHITE);tft.setFont(&Segoe_Script12); tft.setCursor(202,170); tft.print(scanner_G); ora_set = true; orakiir(); break;         
 }  
}

void menu_value_print(int x,int value)
{
byte d = 0;  
if (x==202)
  draw_title(x,147,10);
   else 
    draw_title(x,147,26);
if (value==5) d = 4; 
tft.setTextColor(ILI9341_RED);tft.setFont(&Segoe_Script12);tft.setCursor(x+d,170); tft.print(value); 
}

void set_split_frq()
{
if (split == false)            
       si5351.set_freq(long(vfo*10+7000000), 0, SI5351_CLK2);
        else
         si5351.set_freq(long(vfo_B*10+7000000), 0, SI5351_CLK2);  
}

void scan_buttons()
{
 int b_in = analogRead(A3); //encoder A/B SPLIT  
  if ((b_in==0) && (b_in<10))
   set_frq_step();
   
  if ((b_in>170) && (b_in<190))
  {
    if (menu_index!=0) 
    {
      switch (menu_index)
      {
        case 1: if (wpm > 8) wpm--;
                 menu_value_print(60,wpm); dotLength  = 1200/wpm; break;
        case 2: if (scanner_W == 10) scanner_W = 5;if (scanner_W == 25) scanner_W = 10;if (scanner_W == 50) scanner_W = 25;
                 menu_value_print(157,scanner_W); scanner_start_old = -1; break;                  
        case 3: if (scanner_G > 1) scanner_G--;
                 menu_value_print(202,scanner_G); break;                 
        case 4: if (perc<60) perc++; else perc = 0; orakiir(); break; 
      }
    } 
    else
    {
    long p_start = millis();
     while (analogRead(A3)<900);
    if (millis()-p_start > 200)
     {
       if (osc=='A')
        vfo_B = vfo_A;
         else
          vfo_A = vfo_B;
      delta_f_disp();
     }
     else
      {
        if (split==true)
         {
          split = false; 
          tft.fillRect(230,28,120,4,ILI9341_BLACK);
         }
         else
         {
          split = true;
          draw_line(230);
         }
      }
     set_split_frq(); 
    }  
  }
  if ((b_in>550) && (b_in<580))
  {
   if (menu_index!=0) 
    {
      switch (menu_index)
      {
        case 1: if (wpm < 40) wpm++;
                 menu_value_print(60,wpm); dotLength  = 1200/wpm;break;
        case 2: if (scanner_W == 25) scanner_W = 50;if (scanner_W == 10) scanner_W = 25;if (scanner_W == 5) scanner_W = 10;
                 menu_value_print(157,scanner_W); scanner_start_old = -1; break; 
        case 3: if (scanner_G < 4) scanner_G++;
                 menu_value_print(202,scanner_G); break;                    
        case 4: if (ora<24) ora++; else ora = 0; orakiir(); break;         
      }
    } 
    else
    {
   if (osc=='A')
    {
      osc = 'B';
      vfo_A = vfo;
      vfo = vfo_B;
      tft.fillRect(0,28,120,4,ILI9341_BLACK);
      draw_line(120);
    }
    else
    {
      osc = 'A';
      vfo_B = vfo;
      vfo = vfo_A;
      tft.fillRect(120,28,120,4,ILI9341_BLACK);
      draw_line(0);
    }
      freq_disp(); 
      si5351.set_freq(long (vfo*10+IF+7000000), SI5351_PLL_FIXED, SI5351_CLK0); 
      set_split_frq();
    }
  }
  b_in = analogRead(A2); //left side push buttons  
  long p_start = millis();
   while (analogRead(A2)<10);
    if (millis()-p_start > 200)
     scanner_loop = true;
     else
       if ((b_in==0) && (b_in<10)) //scanner start
        scanner();

   
  if ((b_in>170) && (b_in<190)) //menu
   {
    menu_index++; 
    if (menu_index == 5)
     menu_index = 0;
      menu_setting();
   }

  if ((b_in>550) && (b_in<580)) //tune
  {
    if (tune == false)
     {
      RXtoTX();
      digitalWrite(KEYOUT, LOW); //key on
      analogWrite(sidetoneout,128);
      tune = true; 
     }
      else
       {
        TXtoRX();
        digitalWrite(KEYOUT, HIGH); //key on
        analogWrite(sidetoneout,0);
        tune = false;  
       }
  }  
  if ((b_in>780) && (b_in<800)) //power on off
  {
    if (sleep == false)
     {
      sleep = true;
      digitalWrite(A0,HIGH); //mute on
      tft.fillScreen(ILI9341_BLACK);
      orakiir();
     }
      else
       {
        tft.fillScreen(ILI9341_BLACK);
        digitalWrite(A0,LOW);
        sleep = false;
        vfo_old = vfo + 11111;
        scanner_start_old = -1;
        display_init();
        if (freq_step_index == 0)
         freq_step_index = 3;
          else
           freq_step_index--;
        set_frq_step();
       }
  }    
}

void orakiir()
{
  int x,y;
  if (sleep == true)
   {x = 140; y =100;draw_title(x-10,y,70);}
    else
     {x = 254; y =147;draw_title(x,y,60);}
  if (ora_set == false)
   tft.setTextColor(ILI9341_WHITE);
    else 
     tft.setTextColor(ILI9341_RED);
  tft.setFont(&Segoe_Script12);
  
 if (ora_set == false)
 { 
  if (ido !=9999)
   {
    ora = ido / 60;
    perc = ido % 60;
   }
 }
 else
  ido = ora*60 + perc;
   tft.setCursor(x,y + 23);      
   sido = "";
   if (ora<10)
   {
    sido +="0";
    tft.print("0");
    sido +=(String)ora;
    tft.print(ora);
   }
      else
      {
    sido +=(String)ora;
    tft.print(ora);
      }
    sido += ":";  
    tft.print(":");

   if (perc<10)
   {
    sido += "0"; 
    tft.print("0");
    sido += (String)perc;
    tft.print(perc);
   }
      else
      {
    sido += (String)perc;    
    tft.print(perc);
      }
}

void timerIsr()
{
  if (timer_c<60)
     timer_c++;
      else
      {
    //every 60s
    if (ido<1440)
     ido++;
      else
       ido = 0;
    orakiir();
    
      timer_c = 0;
     }
}

void display_init()
{
tft.setTextColor(ILI9341_WHITE);
tft.setFont(&Ink_Free54);
tft.setCursor(239,110); tft.print(".");
tft.setCursor(53,110); tft.print(".");
tft.setCursor(10,110); tft.print("7");
freq_disp();
delta_f_disp();
tft.setTextColor(ILI9341_WHITE);tft.setFont(&Segoe_Script8);
tft.setCursor(224,120); tft.print("A/B");  
s_bar_print(); 
tft.setFont(&Segoe_Script16);
tft.setTextColor(ILI9341_WHITE);
tft.setCursor(15,30); tft.print("VFO A");
tft.setCursor(124,30); tft.print("VFO B");
tft.setCursor(236,30); tft.print("SPLIT");
draw_line(0);
//alsó sor
draw_title(0,147,90);
draw_title(100,147,130);
draw_title(240,147,80);

tft.setTextColor(ILI9341_WHITE);tft.setFont(&Segoe_Script12);
tft.setCursor(6,170); tft.print("WPM:");
tft.setCursor(60,170); tft.print(wpm);
tft.setCursor(102,170); tft.print("GRID:");
tft.setCursor(157,170); tft.print(scanner_W);
tft.setCursor(183,170); tft.print("K");
tft.setCursor(202,170); tft.print(scanner_G);
tft.setCursor(216,170); tft.print("X");
orakiir();
filter_draw(filter);
scanner();
}

void setup() 
{
pinMode(ILI9341_RESET,OUTPUT);
digitalWrite(ILI9341_RESET,LOW);
delay(100);
digitalWrite(ILI9341_RESET,HIGH);

pinMode(A2,INPUT); 
pinMode(KEYOUT,OUTPUT);digitalWrite(KEYOUT,HIGH); //key -- low active
pinMode(12,OUTPUT);digitalWrite(12,HIGH); //RX = 1 , TX = 0
pinMode(A0,OUTPUT); //mute HIGH active 
digitalWrite(A0,LOW); 


si5351.init(SI5351_CRYSTAL_LOAD_8PF);
si5351.set_pll(SI5351_PLL_FIXED, SI5351_PLLA);
si5351.set_freq(BFO, 0, SI5351_CLK1);
si5351.clock_enable(SI5351_CLK2,0);


#ifdef debug
Serial.begin(115200);
#endif

//clock
ido = ora*60 + perc;
Timer1.initialize(983333); // it is depend from your arduino board's crystal accuracy
Timer1.attachInterrupt(timerIsr); 

tft.begin();      // initialize LCD
tft.setRotation(3);
tft.setCursor(0,0);
tft.fillScreen(ILI9341_BLACK);
tft.setTextSize(1);

//elkey
  // setup input pins
  pinMode (DOTIN, INPUT);
  pinMode (DASHIN, INPUT);
  digitalWrite(DOTIN, HIGH);
  digitalWrite(DASHIN, HIGH);
  pinMode (sidetoneout, OUTPUT);
  analogWrite(sidetoneout,0);
// initialize the state variables 
  lastElt = IDLE; 
  currElt = IDLE;
  nextElt = IDLE; 
  time = millis();
  currEltEndTime = time; 
  dotLength  = 1200/wpm;
//elkey end

  int  k;
  float omega;
  k = (int) (0.5 + ((n * target_freq) / sampling_freq));
  omega = (2.0 * PI * k) / n;
  sine = sin(omega);
  cosine = cos(omega);
  coeff = 2.0 * cosine;

display_init();
}

void TXtoRX()
{
  si5351.clock_enable(SI5351_CLK2,0);
  si5351.clock_enable(SI5351_CLK0,1);
  si5351.clock_enable(SI5351_CLK1,1);
  CLK2 = 0;
  digitalWrite(12,HIGH);
  digitalWrite(A0,LOW);
}

void RXtoTX()
{
  digitalWrite(A0,HIGH); 
  digitalWrite(12,LOW);
  si5351.clock_enable(SI5351_CLK2,1);
  CLK2 = 1;
  si5351.clock_enable(SI5351_CLK0,0);
  si5351.clock_enable(SI5351_CLK1,0);  
}

void loop()
{
if ((CLK2 == 0) || (tune == true)) 
{  
int enc_new = myEnc.read() / 4;
  if (enc_new != enc_old)
  {
    if (scanner_loop == true) scanner_loop = false;
     else
     {
    if (enc_new < enc_old)
     vfo += (enc_old-enc_new)*freq_step;
      else
      {
      vfo -= (enc_new-enc_old)*freq_step;
      if (vfo > 20000) vfo = 0;
      }
    enc_old = enc_new;
    freq_disp(); 
    si5351.set_freq(long (vfo*10+IF+7000000), SI5351_PLL_FIXED, SI5351_CLK0);   
    set_split_frq();
     }
  }
  
  if (millis() > (scan_button_last_time+200))
   {
    scan_buttons();
    scan_button_last_time = millis();
   }
 
   get_signal_magnitude();
   if (millis() > (smeter_last_time+100))
   {
    if (magnitude_avarage / magnitude_avarage_nr > 8000) magnitude_avarage = 8000;
    s_bar((magnitude_avarage / magnitude_avarage_nr)/228);
    smeter_last_time = millis(); 
    magnitude_avarage = 0;
    magnitude_avarage_nr = 0;

    filter = analogRead(A7)/114;
    if (filter_old != filter)
     {
       filter_draw(filter);
       filter_old = filter;
     }  
   }
}
 

//TX --> RX
 if ((currElt == IDLE) && (CLK2 == 1) && (tune == false))
  if (millis() > time_now + vox_delay)
    TXtoRX();
    
//elkey
#ifdef elkey_enabled
// read the paddles
     oldDotVal = dotVal; // save the old values to detect a transition, so you can debounce 
     oldDashVal = dashVal;
     dotVal = digitalRead(DOTIN);  // read the current values of the paddles
     dashVal = digitalRead(DASHIN); 
     //get the current time
      time = millis(); 
     
   switch(currElt) {  // cases based on what current state is 
        
    case DASH:
         if ((dotVal == LOW) && (nextElt == IDLE)) {  // going from dash to iambic mode 
              nextElt = DOT;
        } 
        if (time >= currEltEndTime) {  // at end of current dash
          lastElt = DASH;  // a delay will follow the dash 
          currElt = DELAY; 
         currEltEndTime = time+dotLength;
         } 
         digitalWrite(KEYOUT,LOW);  // close the keyer output while the dash is being sent
         analogWrite(sidetoneout,128);
         break;  
       case DOT: 
        if ((dashVal == LOW) && (nextElt = IDLE)) {  // going from dot to iambic mode
               nextElt = DASH;
         } 
         if (time >= currEltEndTime) {  // at end of current dot 
         lastElt = DOT;  // a delay will follow the dot 
         currElt = DELAY; 
        currEltEndTime = time+dotLength;
      } 
       digitalWrite(KEYOUT,LOW); // close the keyer outout while the dot is being sent
       analogWrite(sidetoneout,128);
      break;  
      
   case IDLE:   // not sending, nor finishing the delay after a dot or dash
      if ((dotVal == LOW) && (dashVal == HIGH)) { // only dot paddle pressed, go to DOT mode 
            if (CLK2 == 0) RXtoTX();
            lastElt = IDLE; 
            currElt = DOT; 
            currEltEndTime = time + dotLength; 
         } else if ((dotVal == HIGH) && (dashVal == LOW)) { // only dash paddle pressed, go to DASH mode
            if (CLK2 == 0) RXtoTX(); 
              lastElt = IDLE; 
            currElt = DASH; 
             currEltEndTime = time + 3*dotLength;  
         } else if ((dotVal == LOW) && (dashVal == LOW) && (nextElt == IDLE)) {  
             // if both paddles hit at same time (rare, but happens)
            if (CLK2 == 0) RXtoTX(); 
            lastElt = IDLE; 
            currElt = DOT; 
            nextElt = DASH; 
            currEltEndTime = time + 3*dotLength; // it is an iambic keyer, not a trochaic keyer
       }
       if (tune == false)
        { 
         digitalWrite(KEYOUT,HIGH);  // keyer output is open in IDLE mode
         analogWrite(sidetoneout,0);
        } 
       break; 
       
     case DELAY:  // waiting for a dot-length delay after sending a dot or dash 
        if (time >= currEltEndTime) {  // check to see if there is a next element to play
        currElt = nextElt; 
        if (currElt == DOT) { 
              currEltEndTime = time+dotLength; 
        } else if ( currElt == DASH) { 
                currEltEndTime = time+3*dotLength;
          }
           lastElt = DELAY; 
            nextElt = IDLE; 
            time_now = millis();   
          }
         // during the delay, if either paddle is pressed, save it to play after the delay
         if ((lastElt == DOT) && (dashVal == LOW) && (nextElt == NULL)) { 
             nextElt = DASH;
          } else if ((lastElt == DASH) && (dotVal == LOW) &&(nextElt == NULL)) { 
             nextElt = DOT; 
          } 
          // key output is open during the delay
          digitalWrite(KEYOUT,HIGH);
          analogWrite(sidetoneout,0);
          break; 
          default:  
          analogWrite(sidetoneout,0);
          digitalWrite(KEYOUT,HIGH);
          break; 
        }

#else
//external keyer
 if (digitalRead(DASHIN)==LOW)
  {
   if (active == 0)
    { 
     RXtoTX(); 
     digitalWrite(KEYOUT, LOW); //key on
     analogWrite(sidetoneout,128);
     active = 1;
    } 
  }
   else
    {
     if (active == 1)
      { 
        active = 0;
        time_now = millis();          
        digitalWrite(KEYOUT, HIGH); //key off
        analogWrite(sidetoneout,0); 
      }  
    }
  
#endif
  
 if (scanner_loop == true)
  scanner();
}
